/**
 * Copyright (c) 2021 Guido Kramann
 *
 * This file is part of a project called kaleidophone - http://www.kramann.info/kaleidophone
 *
 * kaleidophone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * kaleidophone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the kaleidophone. If not, see <http://www.gnu.org/licenses/>.
*/



function Kaleidoskop() //...Darstellung
{
    //float[][][] epaare = new float[6][3][2];
    var epaare;// = new float[6][3][2];
    this.init = function()
    {
         epaare = new Array(6);
         for(var i=0;i<epaare.length;i++)
         {
              epaare[i] = new Array(3);
              for(var k=0;k<epaare[i].length;k++)
              {
                  epaare[i][k] = new Array(2);
                  epaare[i][k][0] = 0.0;
                  epaare[i][k][1] = 0.0;
              }
         }

         var phi = 0.0;
         for(var i=0;i<epaare.length;i++)
         {
              var e1x = Math.cos(phi);
              var e1y = Math.sin(phi);
              var e2x = Math.cos(phi+2.0*Math.PI/6.0);
              var e2y = Math.sin(phi+2.0*Math.PI/6.0);
           
              if(i%2==1)
              {
                 e2x = Math.cos(phi);
                 e2y = Math.sin(phi);
                 e1x = Math.cos(phi+2.0*Math.PI/6.0);
                 e1y = Math.sin(phi+2.0*Math.PI/6.0);
              }
           
              epaare[i][0][0] = e1x;
              epaare[i][0][1] = e1y;
              epaare[i][1][0] = e2x;
              epaare[i][1][1] = e2y;
              epaare[i][2][0] = -e2x-e1x;
              epaare[i][2][1] = -e2y-e1y;
          
              phi+=2.0*Math.PI/6.0;
         }

    }
    
    this.getEpaare = function()
    {
        return epaare;
    }
}




