/**
 * Copyright (c) 2021 Guido Kramann
 *
 * This file is part of a project called kaleidophone - http://www.kramann.info/kaleidophone
 *
 *
 * kaleidophone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * kaleidophone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the kaleidophone. If not, see <http://www.gnu.org/licenses/>.
*/

function PHP()
{
    var szene = null;

    var paramIndex = 0;

    var firstCall;

    this.getParamIndex = function()
    {
        return paramIndex;
    }
    this.init = function(xszene)
    {
        firstCall = new Array(129);
        for(var i=0;i<firstCall.length;i++)
        {
            firstCall[i] = true;
        }
        paramIndex = 0;
        szene = xszene;
        //process();
        if(KOLLABORATE_WITH_OTHERS == true)
        {
          //start cyclic web based sync with others (server communication)
            callForNextParam();
            holeNamen();
        }
    }

    function setWert(pwert,paramIndex)
    {
        if(paramIndex<=124)
        {
            //var ii = Math.floor(pwert/5);
            //var kk = pwert%5;
            //pwert = grid[ii][kk];

            var s = szene.getS();
            var KKK = s.length;
            var i = Math.floor(paramIndex/25);
            var k = Math.floor(paramIndex/5)%5;
            var q = paramIndex%5;
            if(isNaN(pwert))
            {
                    //alert("falscher wert!:"+pwert);
            }
            else
            {
                pwert = Math.round(pwert);
                if(pwert>=0 && pwert<=6)
                {
                    s[KKK-1-k][KKK-1-i][q] = pwert;
                }
                else
                {
                    //alert("falscher wert!:"+pwert);
                }
            }
        }
        else if(paramIndex==125)
        {
            if(isNaN(pwert))
            {
                    //alert("falscher wert!:"+pwert);
            }
            else
            {
               rotX0 = int2double(pwert);
            }
        }
        else if(paramIndex==126)
        {
            if(isNaN(pwert))
            {
                    //alert("falscher wert!:"+pwert);
            }
            else
            {
                rotY0 = int2double(pwert);
            }
        }
        else if(paramIndex==127)
        {
            if(isNaN(pwert))
            {
                    //alert("falscher wert!:"+pwert);
            }
            else
            {
                rotX1 = int2double(pwert);
            }
        }
        else //if(paramIndex==128)
        {
            if(isNaN(pwert))
            {
                    //alert("falscher wert!:"+pwert);
            }
            else
            {
                rotY1 = int2double(pwert);
            }
        }
    }

    this.saveName = function()
    {
            window.document.getElementById("xxsessionid").value=USER_ID;
            window.document.getElementById("xxnickname").value=NICKNAME;


            window.document.getElementById("xspeichername").submit();

    }

    function holeNamen()
    {
            window.document.getElementById("xholenamen").submit();
            var namen = window.document.getElementById("xholenameniframe").contentWindow.document.body.innerHTML;
            zerlegenZiel(ALLENAMEN,namen,"|");
            window.setTimeout(holeNamen, 1000);
    }

    function callForNextParam()
    {

//if(CHANGED[paramIndex]==0)//HACK!!!!!!!! temp
//{
//  firstCall[paramIndex]=true;
//}
        var pwert = 0;
        if(paramIndex<=124)
        {
            //var ii = Math.floor(pwert/5);
            //var kk = pwert%5;
            //pwert = grid[ii][kk];

            var s = szene.getS();
            var KKK = s.length;
            var i = Math.floor(paramIndex/25);
            var k = Math.floor(paramIndex/5)%5;
            var q = paramIndex%5;
            pwert = s[KKK-1-k][KKK-1-i][q];
        }
        else if(paramIndex==125)
        {
            pwert = double2int(rotX0);
        }
        else if(paramIndex==126)
        {
            pwert = double2int(rotY0);
        }
        else if(paramIndex==127)
        {
            pwert = double2int(rotX1);
        }
        else //if(paramIndex==128)
        {
            pwert = double2int(rotY1);
        }


        if(firstCall[paramIndex]==true)
        {
            window.document.getElementById("nummer").value=paramIndex;

            window.document.getElementById("ywert").value=pwert;
            window.document.getElementById("ysessionid").value=USER_ID;
            window.document.getElementById("ynickname").value=NICKNAME;
            window.document.getElementById("ychanged").value=CHANGED[paramIndex];


            window.document.getElementById("holewert").submit();
        }
        else
        {
            window.document.getElementById("xnummer").value=paramIndex;
            window.document.getElementById("xwert").value=pwert;
            window.document.getElementById("xsessionid").value=USER_ID;
            window.document.getElementById("xnickname").value=NICKNAME;
            window.document.getElementById("xchanged").value=CHANGED[paramIndex];
            window.document.getElementById("xspeicherwert").submit();
        }
        //CHANGED[paramIndex] = 0; //????????? hier schon????
    }

    function aufteilen(x)
    {
        var mat = ["","","","",""]; //0wert,1timestamp,2user_id,3nickname,4servertime

        if(x==null || x.length==0)
            return new Array("0","0","0","anonymous","0");

        var u=0;
        for(var i=0;i<x.length;i++)
        {
            var c = x.charAt(i);
            if(c==",")
               u++;
            else
               mat[u]+=c;
        }
        return mat;
    }

    function saveReceivedParam()
    {
        if(firstCall[paramIndex]==true)
        {
            //var AUSDRUCK = window.document.getElementById("holewertiframe").contentWindow.document.body.innerHTML;
            var AUSDRUCK = window.document.getElementById("holewertiframe").contentWindow.document.body.innerHTML;
            //var ARR = AUSDRUCK.split(",",4);
            //if(paramIndex==0) EMPFANGEN = ARR[0]+":"+ARR[1]+":"+ARR[2]+":"+ARR[3];               
            var ARR = aufteilen(AUSDRUCK);
            //EMPFANGEN = AUSDRUCK+" arr="+ARR[0]+":"+ARR[1]+":"+ARR[2]+":"+ARR[3];               
            var WERT = eval(ARR[0]);            
            SERVERDATA[paramIndex][0] = ARR[0]; //wert
            SERVERDATA[paramIndex][1] = ARR[1]; //user id
            SERVERDATA[paramIndex][2] = ARR[2]; //Zeitstempel
            SERVERDATA[paramIndex][3] = ARR[3]; //Nickname
            SERVERTIME = ARR[4];

            //ACTIVEUSER aktualisieren, nur wenn paramIndex==0:
            if(paramIndex==0)
            {
              for(var i=0;i<hACTIVEUSER.length;i++)
              {
                        hACTIVEUSER[i][0]="anonymous";
                        hACTIVEUSER[i][1]="0";
                        hACTIVEUSER[i][2]="0";
              }
              for(var q=0;q<hACTIVEUSER.length;q++)
              {
                var etwas_gefunden = false;
                for(var i=0;i<SERVERDATA.length;i++)
                {
                    var schon_dabei = false;
                    for(var p=0;p<q;p++)
                    {
                        if(hACTIVEUSER[p][2]==SERVERDATA[i][1])
                        {
                            schon_dabei = true;
                            break;
                        }
                    }

                    if(schon_dabei==false && eval(SERVERDATA[i][2])>eval(hACTIVEUSER[q][1])) //wenn neuerer Zeitstempel gefunden wird
                    {
                        hACTIVEUSER[q][0]=SERVERDATA[i][3];//Nickname
                        hACTIVEUSER[q][1]=SERVERDATA[i][2];//Zeitstempel
                        hACTIVEUSER[q][2]=SERVERDATA[i][1];//user id
                        etwas_gefunden = true;
                    }
                }
                if(etwas_gefunden==false)//dieses und rechtliche resetten
                {
                    for(var p=q;p<hACTIVEUSER.length;p++)
                    {
                        hACTIVEUSER[p][0]="anonymous";
                        hACTIVEUSER[p][1]="0";
                        hACTIVEUSER[p][2]="0";
                    }
                    break; //liste der fünf nicht weiter durchgehen
                }
              }

              for(var i=0;i<ACTIVEUSER.length;i++)
                 for(var k=0;k<ACTIVEUSER[i].length;k++)
                      ACTIVEUSER[i][k] = hACTIVEUSER[i][k];
            }


            if(isNaN(WERT))
            {
            }
            else
            {
               setWert(WERT,paramIndex);
               EMPFANGEN = "Empfangen: p["+paramIndex+"] = "+WERT;//+" w1="+W1+" w2="+W2+" w3="+W3;
//NUR dauernd laden
//               firstCall[paramIndex]=false;
            }
        }
        else
        {
            var WERT = window.document.getElementById("xspeicherwertiframe").contentWindow.document.body.innerHTML;
            if(isNaN(WERT))
            {
            }
            else
            {
                setWert(WERT,paramIndex);
                EMPFANGEN = "Empfangen: p["+paramIndex+"] = "+WERT;
//NUR dauernd laden
//                firstCall[paramIndex]=false;
            }
        }


        
        paramIndex++;
        if(paramIndex>=129)
        {
              paramIndex = 0;
        }
        callForNextParam();
    }
    this.saveReceivedParam = function(){saveReceivedParam();}

    function getTimeFromServer()
    {
        window.document.getElementById("systemtime").submit();
    }

    function updateTime()
    {
        TIME = eval(window.document.getElementById("systemtimeiframe").contentWindow.document.body.innerHTML);
    }

    function holeWert(nummer)
    {
        window.document.getElementById("nummer").value=nummer;
        window.document.getElementById("holewert").submit();
        return eval(window.document.getElementById("holewertiframe").contentWindow.document.body.innerHTML);
    }
    this.holeWert = function(nummer){return holeWert(nummer);}   

    function speicherEventuellWert(xnummer,xwert,xsessionid,xnickname)
    {
        window.document.getElementById("xnummer").value=xnummer;
        window.document.getElementById("xwert").value=xwert;
        window.document.getElementById("xsessionid").value=xsessionid;
        window.document.getElementById("xnickname").value=xnickname;
        window.document.getElementById("xspeicherwert").submit();
        return eval(window.document.getElementById("xspeicherwertiframe").contentWindow.document.body.innerHTML);
    }
      

    function process()
    {
        getTimeFromServer();
        updateTime();
        //TESTWERT = holeWert(0);

        //Alle Werte durchgehen und ev. auf Server speichern, oder wenn Serverwert dominiert diesen übernehmen:

        var iiii=0;
                 if(grid!=null)
                 {
                      var s = szene.getS();
                      var ii=0;
                      var KKK = s.length
                      for(var i=0;i<s.length;i++)
                      {
                          for(var k=0;k<s[i].length;k++)
                          {
                              for(var q=0;q<s[i][k].length;q++)
                              {
                                  iiii = ii*5+q;
                                  var WERTAKTUELL = s[KKK-1-k][KKK-1-i][q];
                                  //grid[ii][q] = speicherEventuellWert(xnummer,xwert,xsessionid,xnickname);
                                  grid[ii][q] = speicherEventuellWert(iiii,WERTAKTUELL,USER_ID,NICKNAME);
                                  s[KKK-1-k][KKK-1-i][q] = grid[ii][q];
                              }
                              ii++;
                          }
                      }
                 }
        //initial rotation of all three projections 
        rotX0 = int2double(  speicherEventuellWert(125,double2int(rotX0),USER_ID,NICKNAME)  );
        rotY0 = int2double(  speicherEventuellWert(126,double2int(rotY0),USER_ID,NICKNAME)  );
        rotX1 = int2double(  speicherEventuellWert(127,double2int(rotX1),USER_ID,NICKNAME)  );
        rotY1 = int2double(  speicherEventuellWert(128,double2int(rotY1),USER_ID,NICKNAME)  );

        window.setTimeout(process, 1000);
    }
}


